Debian Bug report logs - #637231
Moving Digest::SHA to perl-base

version graph

Package: hurd; Maintainer for hurd is GNU Hurd Maintainers <debian-hurd@lists.debian.org>; Source for hurd is src:hurd.

Reported by: Dominic Hargreaves <dom@earth.li>

Date: Tue, 9 Aug 2011 17:30:01 UTC

Severity: wishlist

Fixed in version hurd/20111106-1

Done: Samuel Thibault <sthibault@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, pino@debian.org, Niko Tyni <ntyni@debian.org>:
Bug#637231; Package perl-base. (Tue, 09 Aug 2011 17:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominic Hargreaves <dom@earth.li>:
New Bug report received and forwarded. Copy sent to pino@debian.org, Niko Tyni <ntyni@debian.org>. (Tue, 09 Aug 2011 17:30:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Dominic Hargreaves <dom@earth.li>
To: submit@packages.debian.org
Subject: Re: Moving Digest::SHA to perl-base
Date: Tue, 9 Aug 2011 18:26:43 +0100
Package: perl-base
Severity: wishlist

On Tue, Aug 09, 2011 at 12:31:43AM +0200, gregor herrmann wrote:
> On Tue, 09 Aug 2011 00:24:02 +0200, Pino Toscano wrote:
> 
> > Hi Perl people,
> 
> Hi Hurd guys :)
>  
> > The short story is: we, Debian Hurd packagers, would like to see 
> > Digest::SHA moved from "perl" to "perl-base".
> > 
> > We are preparing to upload from debian-ports to Debian main a simple 
> > Hurd translator, random-egd, to provide /dev/{,u}random devices. This 
> > translator interfaces to a small init.d service written in Perl, a 
> > slightly modified version of EGD (egd.pl). egd.pl uses sha1() from 
> > Digest::SHA1 (which we changed to Digest::SHA, as Digest::SHA1 is 
> > deprecated).
> > The problem is that we need random-egd as dependency of the "hurd" 
> > package (essential on hurd), so it must be essential too; although, 
> > currently it cannot because Digest::SHA is in "perl", which is not an 
> > essential package. Our proposal is whether you could move Digest::SHA 
> > from "perl" to "perl-base".
> > 
> > (PS: please CC me in replies, as I'm not subscribed)
> 
> CC'ing the perl maintainers (the Perl Group is "only" for packacging
> modules, not the interpreter itself).

This sounds like a reasonable request. Filing this as a wishlist bug.

Digest::SHA also uses Digest::base and MIME::Base64, which will also need
moving. 

Niko, any comments?

Cheers,
Dominic.

-- 
Dominic Hargreaves | http://www.larted.org.uk/~dom/
PGP key 5178E2A5 from the.earth.li (keyserver,web,email)




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#637231; Package perl-base. (Wed, 10 Aug 2011 06:42:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. (Wed, 10 Aug 2011 06:42:04 GMT) Full text and rfc822 format available.

Message #10 received at 637231@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: Pino Toscano <pino@debian.org>
Cc: debian-perl@lists.debian.org, 637231@bugs.debian.org
Subject: Re: Moving Digest::SHA to perl-base
Date: Wed, 10 Aug 2011 09:39:44 +0300
On Tue, Aug 09, 2011 at 12:24:02AM +0200, Pino Toscano wrote:

> The short story is: we, Debian Hurd packagers, would like to see 
> Digest::SHA moved from "perl" to "perl-base".

As discussed in the policy (section 3.8, "Essential packages"), adding
functionality to the Essential set is not something to do lightly.
So I'd like to explore any alternatives first, particularly as this
is only needed on an unofficial architecture but would affect all the
installer footprint on official ones too.

> We are preparing to upload from debian-ports to Debian main a simple 
> Hurd translator, random-egd, to provide /dev/{,u}random devices. This 
> translator interfaces to a small init.d service written in Perl, a 
> slightly modified version of EGD (egd.pl). egd.pl uses sha1() from 
> Digest::SHA1 (which we changed to Digest::SHA, as Digest::SHA1 is 
> deprecated).
> The problem is that we need random-egd as dependency of the "hurd" 
> package (essential on hurd), so it must be essential too; although, 
> currently it cannot because Digest::SHA is in "perl", which is not an 
> essential package. Our proposal is whether you could move Digest::SHA 
> from "perl" to "perl-base".

Not all dependencies of essential packages need to be essential.
The requirement for staying usable even when unconfigured only applies
to the "core functionality" of the essential packages. I suppose
/dev/{,u}random needs to be regarded part of that?

Most essential packages declare Pre-Depends entries when their core
functionality does need non-essential packages (mainly libc*). However,
I doubt a Pre-Depends: perl would work in all scenarios involving system
upgrades.

I see /usr/bin/sha1sum is already in the Essential set. Would it
be viable to fork that and compute the SHA checksums through a pipe?
I expect performance is not a real issue here, given the choice of Perl
for such a low level daemon in the first place.
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Niko Tyni <ntyni@debian.org>:
Bug#637231; Package perl-base. (Thu, 11 Aug 2011 15:54:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <sthibault@debian.org>:
Extra info received and forwarded to list. Copy sent to Niko Tyni <ntyni@debian.org>. (Thu, 11 Aug 2011 15:54:07 GMT) Full text and rfc822 format available.

Message #15 received at 637231@bugs.debian.org (full text, mbox):

From: Samuel Thibault <sthibault@debian.org>
To: 637231@bugs.debian.org, debian-perl@lists.debian.org
Cc: Pino Toscano <pino@debian.org>
Subject: Re: Bug#637231: Moving Digest::SHA to perl-base
Date: Thu, 11 Aug 2011 17:50:35 +0200
Niko Tyni, le Wed 10 Aug 2011 09:39:44 +0300, a écrit :
> As discussed in the policy (section 3.8, "Essential packages"), adding
> functionality to the Essential set is not something to do lightly.

Sure.

> > We are preparing to upload from debian-ports to Debian main a simple 
> > Hurd translator, random-egd, to provide /dev/{,u}random devices. This 
> > translator interfaces to a small init.d service written in Perl, a 
> > slightly modified version of EGD (egd.pl). egd.pl uses sha1() from 
> > Digest::SHA1 (which we changed to Digest::SHA, as Digest::SHA1 is 
> > deprecated).
> > The problem is that we need random-egd as dependency of the "hurd" 
> > package (essential on hurd), so it must be essential too; although, 
> > currently it cannot because Digest::SHA is in "perl", which is not an 
> > essential package. Our proposal is whether you could move Digest::SHA 
> > from "perl" to "perl-base".
> 
> Not all dependencies of essential packages need to be essential.
> The requirement for staying usable even when unconfigured only applies
> to the "core functionality" of the essential packages. I suppose
> /dev/{,u}random needs to be regarded part of that?

Mmm. Up to now we have mostly missed the random entries for the ssh
server, which is obviously not core functionality. At the moment,
bootstrapping a Debian system works with random entries.

That said, it's not only about being essential, but also package
priority, perl is not required.

> I see /usr/bin/sha1sum is already in the Essential set. Would it
> be viable to fork that and compute the SHA checksums through a pipe?
> I expect performance is not a real issue here, given the choice of Perl
> for such a low level daemon in the first place.

Right, we'll try that.

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Niko Tyni <ntyni@debian.org>:
Bug#637231; Package perl-base. (Fri, 12 Aug 2011 01:09:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <sthibault@debian.org>:
Extra info received and forwarded to list. Copy sent to Niko Tyni <ntyni@debian.org>. (Fri, 12 Aug 2011 01:09:06 GMT) Full text and rfc822 format available.

Message #20 received at 637231@bugs.debian.org (full text, mbox):

From: Samuel Thibault <sthibault@debian.org>
To: 637231@bugs.debian.org, debian-perl@lists.debian.org, Pino Toscano <pino@debian.org>
Subject: Re: Bug#637231: Moving Digest::SHA to perl-base
Date: Fri, 12 Aug 2011 03:06:00 +0200
Samuel Thibault, le Thu 11 Aug 2011 17:50:35 +0200, a écrit :
> That said, it's not only about being essential, but also package
> priority, perl is not required.
> 
> > I see /usr/bin/sha1sum is already in the Essential set. Would it
> > be viable to fork that and compute the SHA checksums through a pipe?
> > I expect performance is not a real issue here, given the choice of Perl
> > for such a low level daemon in the first place.
> 
> Right, we'll try that.

It works but makes it impractical. Connecting via ssh now takes a few
seconds, and sshd startup takes more than a few minutes (I didn't have
the patience to measure more)...

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Niko Tyni <ntyni@debian.org>:
Bug#637231; Package perl-base. (Fri, 12 Aug 2011 03:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Kahn Gillmor <dkg@fifthhorseman.net>:
Extra info received and forwarded to list. Copy sent to Niko Tyni <ntyni@debian.org>. (Fri, 12 Aug 2011 03:09:03 GMT) Full text and rfc822 format available.

Message #25 received at 637231@bugs.debian.org (full text, mbox):

From: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
To: 637231@bugs.debian.org, debian-perl@lists.debian.org, Pino Toscano <pino@debian.org>, Samuel Thibault <sthibault@debian.org>
Subject: Re: Bug#637231: Moving Digest::SHA to perl-base
Date: Thu, 11 Aug 2011 23:07:22 -0400
[Message part 1 (text/plain, inline)]
On 08/11/2011 09:06 PM, Samuel Thibault wrote:
> Samuel Thibault, le Thu 11 Aug 2011 17:50:35 +0200, a écrit :
>> That said, it's not only about being essential, but also package
>> priority, perl is not required.
>>
>>> I see /usr/bin/sha1sum is already in the Essential set. Would it
>>> be viable to fork that and compute the SHA checksums through a pipe?
>>> I expect performance is not a real issue here, given the choice of Perl
>>> for such a low level daemon in the first place.
>>
>> Right, we'll try that.
> 
> It works but makes it impractical. Connecting via ssh now takes a few
> seconds, and sshd startup takes more than a few minutes (I didn't have
> the patience to measure more)...

Just some thoughts to consider:

0) I see a number of other /dev/random options at:

  https://www.gnu.org/software/hurd/hurd/translator/random.html

Have they all been explored and rejected for some reason or another?

1) I wonder also whether something like haveged could be modifiable into
a hurd translator:

 http://www.issihosts.com/haveged/#news

2) lastly, is it possible to introduce an architecture-specific
dependency somehow?  If we can find a way to do this cleanly, it might
make it easier to move forward with hurd without needing to disrupt the
other architectures as much.

thanks for working on this,

	--dkg

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Niko Tyni <ntyni@debian.org>:
Bug#637231; Package perl-base. (Sun, 30 Oct 2011 20:42:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <sthibault@debian.org>:
Extra info received and forwarded to list. Copy sent to Niko Tyni <ntyni@debian.org>. (Sun, 30 Oct 2011 20:42:09 GMT) Full text and rfc822 format available.

Message #30 received at 637231@bugs.debian.org (full text, mbox):

From: Samuel Thibault <sthibault@debian.org>
To: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Cc: 637231@bugs.debian.org, debian-perl@lists.debian.org, Pino Toscano <pino@debian.org>
Subject: Re: Bug#637231: Moving Digest::SHA to perl-base
Date: Sun, 30 Oct 2011 21:40:13 +0100
reassign 637231 hurd
thanks

Daniel Kahn Gillmor, le Thu 11 Aug 2011 23:07:22 -0400, a écrit :
> 0) I see a number of other /dev/random options at:
> 
>   https://www.gnu.org/software/hurd/hurd/translator/random.html
> 
> Have they all been explored and rejected for some reason or another?

I thought they were.  We had another look, and the version from Marcus
should provide a good core alternative, which won't need perl, thus
reassigning the bug to the hurd package.

Samuel




Added tag(s) pending. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Sun, 30 Oct 2011 20:57:02 GMT) Full text and rfc822 format available.

Message sent on to Dominic Hargreaves <dom@earth.li>:
Bug#637231. (Sun, 30 Oct 2011 20:57:05 GMT) Full text and rfc822 format available.

Message #35 received at 637231-submitter@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: 637231-submitter@bugs.debian.org
Subject: Bug#637231 marked as pending
Date: Sun, 30 Oct 2011 20:53:56 +0000
tag 637231 pending
thanks

Hello,

Bug #637231 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=pkg-hurd/hurd.git;a=commitdiff;h=f85108c

---
commit f85108c64e76e02156956018f43ab2bfa1be2cc4
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Sun Oct 30 21:39:37 2011 +0100

    close bug about perl sha1  module

diff --git a/debian/changelog b/debian/changelog
index 44c25c1..f341670 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -15,6 +15,7 @@ hurd (20111030-1) UNRELEASED; urgency=low
   * patches/libpthread_procfs.patch: Add random server.
   * debian/control, debian/local/setup-translators: Use native random server
     set on /dev/u?random-hurd instead of random-egd on /dev/u?random.
+    (Closes: bug#637231)
   * debian/hurd.{postinst,prerm}: Handle alternative for /dev/u?random,
     default to u?random-hurd.
   * debian/hurd.lintian-overrides: Override warnings about the /dev/u?random




Bug reassigned from package 'perl-base' to 'hurd'. Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Sun, 30 Oct 2011 21:48:03 GMT) Full text and rfc822 format available.

Reply sent to Samuel Thibault <sthibault@debian.org>:
You have taken responsibility. (Sun, 06 Nov 2011 16:21:08 GMT) Full text and rfc822 format available.

Notification sent to Dominic Hargreaves <dom@earth.li>:
Bug acknowledged by developer. (Sun, 06 Nov 2011 16:21:08 GMT) Full text and rfc822 format available.

Message #42 received at 637231-close@bugs.debian.org (full text, mbox):

From: Samuel Thibault <sthibault@debian.org>
To: 637231-close@bugs.debian.org
Subject: Bug#637231: fixed in hurd 20111106-1
Date: Sun, 06 Nov 2011 16:18:33 +0000
Source: hurd
Source-Version: 20111106-1

We believe that the bug you reported is fixed in the latest version of
hurd, which is due to be installed in the Debian FTP archive:

hurd-dbg_20111106-1_hurd-i386.deb
  to main/h/hurd/hurd-dbg_20111106-1_hurd-i386.deb
hurd-dev_20111106-1_hurd-i386.deb
  to main/h/hurd/hurd-dev_20111106-1_hurd-i386.deb
hurd-doc_20111106-1_all.deb
  to main/h/hurd/hurd-doc_20111106-1_all.deb
hurd-udeb_20111106-1_hurd-i386.udeb
  to main/h/hurd/hurd-udeb_20111106-1_hurd-i386.udeb
hurd_20111106-1.debian.tar.bz2
  to main/h/hurd/hurd_20111106-1.debian.tar.bz2
hurd_20111106-1.dsc
  to main/h/hurd/hurd_20111106-1.dsc
hurd_20111106-1_hurd-i386.deb
  to main/h/hurd/hurd_20111106-1_hurd-i386.deb
hurd_20111106.orig.tar.gz
  to main/h/hurd/hurd_20111106.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 637231@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Samuel Thibault <sthibault@debian.org> (supplier of updated hurd package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Thu, 18 Aug 2011 01:15:04 +0000
Source: hurd
Binary: hurd hurd-dev hurd-dbg hurd-doc hurd-udeb
Architecture: source all hurd-i386
Version: 20111106-1
Distribution: unstable
Urgency: low
Maintainer: GNU Hurd Maintainers <debian-hurd@lists.debian.org>
Changed-By: Samuel Thibault <sthibault@debian.org>
Description: 
 hurd       - GNU Hurd
 hurd-dbg   - GNU Hurd (debugging files)
 hurd-dev   - GNU Hurd (development files)
 hurd-doc   - GNU Hurd manual
 hurd-udeb  - GNU Hurd - udeb (udeb)
Closes: 637231 639010
Changes: 
 hurd (20111106-1) unstable; urgency=low
 .
   * New upstream snapshot.
     - Drop debian/patches/ttys.patch.patch, applied upstream.
     - Drop debian/patches/auth-intr-cure.patch, applied upstream.
     - Drop debian/patches/libpthread_tls.patch, applied upstream.
     - debian/patches/libpthread_procfs.patch: Refresh.
     - Closes: #639010.
   * local/setup-translators:
     - Restore /dev/shm creation.
     - create /run/shm and /run/lock, to fix locking until we properly start
     rcS.d scripts.
     - Add cd[01] SCSI CD-ROMs.
   * patches/libdiskfs_sync.patch: New patch to fix sync at shutdown.
   * patches/libpthread_procfs.patch: Add random server.
   * local/setup-translators: Use random server, set up its entropy pool in
     /var/spool.
   * debian/control, debian/local/setup-translators: Use native random server
     set on /dev/u?random-hurd instead of random-egd on /dev/u?random.
     (Closes: bug#637231)
   * debian/hurd.{postinst,prerm}: Handle alternative for /dev/u?random,
     default to u?random-hurd, generate an initial pseudo-random seed.
   * debian/hurd.lintian-overrides: Override warnings about the /dev/u?random
     mangling.
   * debian/local/cdrom.h: Add header for basic CD-ROM ioctl support.
   * debian/patches/libpthread_globsigdisp.patch,posix-sigcodes.patch: New
     patches from Jeremie Koenig to enable global signal support.
   * debian/patches/libpthread_sigmask.patch: Update to global signal support.
   * debian/copyright: Fix copyright notice.
   * debian/control:
     - Drop article from synopsis.
     - Tighten hurd-dev dependency on hurd to the same version.
   * debian/hurd-udeb.install: Only include the necessary console drivers.
   * debian/patches/random-default-fast.patch: Set default randomness to fast,
     until we set up a daemon to feed /dev/random with entropy.
Checksums-Sha1: 
 0b91a7793dd30aed926bcbf2c00c7233047407ef 1752 hurd_20111106-1.dsc
 64c3c2abf855ff7eae95a2ed357949a8ebc57c77 2716558 hurd_20111106.orig.tar.gz
 dd8085aaf5d65acf33522b1cec8532439b620bdc 84123 hurd_20111106-1.debian.tar.bz2
 6b431e9c81e68c5ffb67cd7ee3a35e4c4935a295 197844 hurd-doc_20111106-1_all.deb
 28c754f1a939656294615c0db27443e43e792983 3617794 hurd_20111106-1_hurd-i386.deb
 4ffd29e2c9bc9b7b0d177e3dae14ec9d60d5c1cb 590050 hurd-dev_20111106-1_hurd-i386.deb
 baad24d219d30b52208539293abc10859159ad5e 6505862 hurd-dbg_20111106-1_hurd-i386.deb
 42dd2d2cb3ea0545f42ae4d47249361c6b5f4e14 2046868 hurd-udeb_20111106-1_hurd-i386.udeb
Checksums-Sha256: 
 4a70e9476b6102ef8b0ec6b9f457cb5392c4558b96fcc5719fc3b0736e902bcf 1752 hurd_20111106-1.dsc
 8a375827c10719418df82f2e769375831974d915fff1b9cc46aae9fbe59d86e7 2716558 hurd_20111106.orig.tar.gz
 8be5499f32dd6af5aa142a2e10f1797960e250ace7dd574109e967e3b23bf8fc 84123 hurd_20111106-1.debian.tar.bz2
 6484b08abd9ef329be9a651c2ab71854b429bfb0a5a7049d9b627b774f79f88e 197844 hurd-doc_20111106-1_all.deb
 f0d18858263ade6be4a961fec9a808ee705b3a266116fc339d3d6461dcb4a488 3617794 hurd_20111106-1_hurd-i386.deb
 a0bb95749dcbb82736eea4c448f2a66404af7f5745644bb67c0b1d1b72356b07 590050 hurd-dev_20111106-1_hurd-i386.deb
 9614d3d2b64e94ffd6214b7930aeb4b888736955d60a6bb4d67fcd2ba8760b99 6505862 hurd-dbg_20111106-1_hurd-i386.deb
 869f9e8b851b57efb3125575021a472293d5972808fd223bca95e2982bbd6645 2046868 hurd-udeb_20111106-1_hurd-i386.udeb
Files: 
 1bdb4251ba58980257b00dee0b101bcc 1752 admin required hurd_20111106-1.dsc
 25b17d7eb15bb9673271ea1667ce679f 2716558 admin required hurd_20111106.orig.tar.gz
 34a58656b31e518ebd631729c12261bb 84123 admin required hurd_20111106-1.debian.tar.bz2
 fcc67c390cecd5e6247fc27537c16535 197844 doc optional hurd-doc_20111106-1_all.deb
 07990ee279d979afb59d845a376eddbf 3617794 admin required hurd_20111106-1_hurd-i386.deb
 81d556dc1557360f98301ccd516f98ef 590050 libdevel standard hurd-dev_20111106-1_hurd-i386.deb
 1919a3e61bc7d5c7edf75cac324f03d9 6505862 debug extra hurd-dbg_20111106-1_hurd-i386.deb
 68465abec60c09ddaa37e53ebc95b1a8 2046868 debian-installer optional hurd-udeb_20111106-1_hurd-i386.udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iF4EAREKAAYFAk62sREACgkQa6Lp0s/HjrMtFQD/XGA/KrHbgUtKPfOoE4fk31nf
+U6VXkthwmwv2sW320sA/ijP+x54eICNUOEAeViw59jGGW3Smjb9Wc5b0WOxLatf
=gOxa
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 05 Dec 2011 07:36:21 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 05:54:21 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.